function CMain(oData){
    var _bUpdate;
    var _iCurResource = 0;
    var RESOURCE_TO_LOAD = 0;
    var _iState = STATE_LOADING;
    var _oData;
    
    var _oPreloader;
    var _oMenu;
    var _oModeMenu;
    var _oHelp;
    var _oGame;

    this.initContainer = function(){
        
        s_oDrawCanvas = document.getElementById("draw_canvas");
        s_oDrawStage = new createjs.Stage(s_oDrawCanvas);
        
        s_oCanvas = document.getElementById("canvas");
        s_oStage = new createjs.Stage(s_oCanvas);
        
        s_oInteractiveCanvas = document.getElementById("interactivecanvas");
        s_oInteractiveStage = new createjs.Stage(s_oInteractiveCanvas);
        createjs.Touch.enable(s_oInteractiveStage);
        
		
	s_bMobile = jQuery.browser.mobile;
        if(s_bMobile === false){
            s_oStage.enableMouseOver(FPS);
            s_oInteractiveStage.enableMouseOver(FPS);
            $('body').on('contextmenu', '#canvas', function(e){ return false; });
        }
		
        s_iPrevTime = new Date().getTime();

	createjs.Ticker.addEventListener("tick", this._update);
        createjs.Ticker.setFPS(FPS);
        
        if(navigator.userAgent.match(/Windows Phone/i)){
                DISABLE_SOUND_MOBILE = true;
        }
        
        s_oSpriteLibrary  = new CSpriteLibrary();

        //ADD PRELOADER
        _oPreloader = new CPreloader();
	
    };
    
    this.preloaderReady = function(){
        /*usman
		if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
           this._initSounds();
        }usman*/
        
        this._loadImages();
        _bUpdate = true;
    };
    
    this.soundLoaded = function(){
        _iCurResource++;
        var iPerc = Math.floor(_iCurResource/RESOURCE_TO_LOAD *100);
        _oPreloader.refreshLoader(iPerc);

         if(_iCurResource === RESOURCE_TO_LOAD){
            s_oMain._onAllResourcesLoaded();
         }
    };
    
    this._initSounds = function(){
        
        var aSoundsInfo = new Array();
        
        aSoundsInfo.push({path: './sounds/',filename:'soundtrack',loop:true,volume:1, ingamename: 'soundtrack'});
        aSoundsInfo.push({path: './sounds/',filename:'press_button',loop:false,volume:1, ingamename: 'click'});


        RESOURCE_TO_LOAD += aSoundsInfo.length;

        s_aSounds = new Array();
        for(var i=0; i<aSoundsInfo.length; i++){
            s_aSounds[aSoundsInfo[i].ingamename] = new Howl({ 
                                                            src: [aSoundsInfo[i].path+aSoundsInfo[i].filename+'.mp3', aSoundsInfo[i].path+aSoundsInfo[i].filename+'.ogg'],
                                                            autoplay: false,
                                                            preload: true,
                                                            loop: aSoundsInfo[i].loop, 
                                                            volume: aSoundsInfo[i].volume,
                                                            onload: s_oMain.soundLoaded
                                                        });
        }

    };

    this._loadImages = function(){
        s_oSpriteLibrary.init( this._onImagesLoaded,this._onAllImagesLoaded, this );

        //s_oSpriteLibrary.addSprite("but_play","./sprites/but_play.png");
        s_oSpriteLibrary.addSprite("ctl_logo","./../../../common/sprites/ctl_logo.png");
        //s_oSpriteLibrary.addSprite("but_fullscreen","./sprites/but_fullscreen.png");
        //s_oSpriteLibrary.addSprite("but_credits","./sprites/but_credits.png");
        s_oSpriteLibrary.addSprite("msg_box","./../../../common/sprites/msg_box.png");
        
        //s_oSpriteLibrary.addSprite("bg_menu","./sprites/bg_menu.jpg");
        //s_oSpriteLibrary.addSprite("bg_modemenu","./sprites/bg_modemenu.jpg"); 
        s_oSpriteLibrary.addSprite("bg_game","./../../../common/sprites/bg_game.jpg");

        //s_oSpriteLibrary.addSprite("but_exit","./sprites/but_exit.png");
        //s_oSpriteLibrary.addSprite("audio_icon","./sprites/audio_icon.png");
        //s_oSpriteLibrary.addSprite("but_save","./sprites/but_save.png");
        //s_oSpriteLibrary.addSprite("but_print","./sprites/but_print.png");
        s_oSpriteLibrary.addSprite("but_restart","./../../../common/sprites/but_restart.png");
        s_oSpriteLibrary.addSprite("eraser","./../../../common/sprites/eraser.png");
        s_oSpriteLibrary.addSprite("sliderbox","./../../../common/sprites/sliderbox.png");
        s_oSpriteLibrary.addSprite("slider","./../../../common/sprites/slider.png");
        s_oSpriteLibrary.addSprite("pen","./../../../common/sprites/pen.png");
        s_oSpriteLibrary.addSprite("canvas_drawing","./../../../common/sprites/drawcanvas.jpg");
        s_oSpriteLibrary.addSprite("drawcanvas_frame","./../../../common/sprites/drawcanvas_frame.png");
        
        //s_oSpriteLibrary.addSprite("image1","./sprites/image1.png");
        s_oSpriteLibrary.addSprite("image2",path);
        //s_oSpriteLibrary.addSprite("image2","./sprites/image2.png");
        //s_oSpriteLibrary.addSprite("image3","./sprites/image3.png");
        //s_oSpriteLibrary.addSprite("image4","./sprites/image4.png");
        //s_oSpriteLibrary.addSprite("image5","./sprites/image5.png");
        //s_oSpriteLibrary.addSprite("image6","./sprites/image6.png");

        
        RESOURCE_TO_LOAD += s_oSpriteLibrary.getNumSprites();
        s_oSpriteLibrary.loadSprites();
    };
    
    this._onImagesLoaded = function(){
        _iCurResource++;
        var iPerc = Math.floor(_iCurResource/RESOURCE_TO_LOAD *100);
        _oPreloader.refreshLoader(iPerc);
        
        if(_iCurResource === RESOURCE_TO_LOAD){
            s_oMain._onAllResourcesLoaded();
        }
    };
    
    this._onAllImagesLoaded = function(){
        
    };
    
    this.onAllPreloaderImagesLoaded = function(){
        this._loadImages();
    };
    
    this._onAllResourcesLoaded = function(){
        _oPreloader.unload();

        /*usman
		if (!isIOS()) {
            playSound("soundtrack", 1, true);
        }usman*/

        //this.gotoMenu();
		  this.gotoGame('image2');
    };
    
    this.gotoMenu = function(){
        _oMenu = new CMenu();
        _iState = STATE_MENU;
    };
    
    
    this.gotoModeMenu = function(){
        _oModeMenu = new CModeMenu();
        _iState = STATE_MENU;
    };
    

    this.gotoGame = function(szDraw){
        s_szCurDraw = szDraw;
        _oGame = new CGame(_oData);   						
        _iState = STATE_GAME;

    };
    
    this.gotoHelp = function(){
        _oHelp = new CHelp();
        _iState = STATE_HELP;
    };
	
    this.stopUpdate = function(){
        _bUpdate = false;
        createjs.Ticker.paused = true;
        $("#block_game").css("display","block");
        Howler.mute(true);
     };

    this.startUpdate = function(){
        s_iPrevTime = new Date().getTime();
        _bUpdate = true;
        createjs.Ticker.paused = false;
        $("#block_game").css("display","none");

        if(s_bAudioActive){
                Howler.mute(false);
        }
    };
    
    this._update = function(){
		if(_bUpdate === false){
			return;
		}
        var iCurTime = new Date().getTime();
        s_iTimeElaps = iCurTime - s_iPrevTime;
        s_iCntTime += s_iTimeElaps;
        s_iCntFps++;
        s_iPrevTime = iCurTime;
        
        if ( s_iCntTime >= 1000 ){
            s_iCurFps = s_iCntFps;
            s_iCntTime-=1000;
            s_iCntFps = 0;
        } 

    };
    
    ENABLE_FULLSCREEN = oData.fullscreen;
    ENABLE_CHECK_ORIENTATION = oData.check_orientation;
    
    s_oMain = this;
    
    _oData = oData;
    
    this.initContainer();
}
var s_bMobile;
var s_bAudioActive = true;
var s_iCntTime = 0;
var s_iTimeElaps = 0;
var s_iPrevTime = 0;
var s_iCntFps = 0;
var s_iCurFps = 0;
var s_szCurDraw;
var s_bFullscreen = false;

var s_oStage;
var s_oMain;
var s_oSpriteLibrary;
var s_oSoundTrack;
var s_oCanvas;
var s_oDrawCanvas;
var s_oDrawStage;
var s_oInteractiveCanvas;
var s_oInteractiveStage;
var s_aSounds = new Array();
